<template>
  <Field name="AnimalForm" ref="formBis">
    <v-row>
      <v-col cols="12" class="text-h6 font-weight-bold">
        Animal
      </v-col>
      <v-col cols="12" sm="4">
        <Field #default="{ errors, field, value }" :immediate="!!animal.id" name="AnimalName" rules="required|max:50"
          v-model="animal.animalName">
          <v-text-field @update:model-value="field.onChange" :model-value="value" label="Nom"
            data-cy="AnimalFormAnimalNameInput" density="compact" :error-messages="errors" variant="outlined" class="required">
          </v-text-field>
        </Field>
      </v-col>
      <v-col cols="12" sm="4">
        <Field #default="{ errors, field, value }" :immediate="!!animal.id" name="AnimalId" rules="required|max:50"
          v-model="animal.animalId">
          <v-text-field @update:model-value="field.onChange" :model-value="value" label="Matricule"
            data-cy="AnimalFormAnimalIdInput" density="compact" :error-messages="errors" variant="outlined" class="required">
          </v-text-field>
        </Field>
      </v-col>
      <v-col cols="12" sm="4">
        <Field #default="{ errors, field, value }" :immediate="!!animal.id" name="AnimalUnit" rules="required|max:50"
          v-model="animal.animalUnit">
          <v-text-field @update:model-value="field.onChange" :model-value="value" label="Unité"
            data-cy="AnimalFormAnimalUnitInput" density="compact" :error-messages="errors" class="required" variant="outlined">
          </v-text-field>
        </Field>
      </v-col>


      <v-col cols="12" class="text-h6 font-weight-bold">
        Maître-Chien
      </v-col>
      <v-col cols="12" sm="4">
        <Field #default="{ errors, field, value }" :immediate="!!animal.id" name="OwnerName" rules="required|max:100"
          v-model="animal.ownerName">
          <v-text-field @update:model-value="field.onChange" :model-value="value" label="Nom"
            data-cy="AnimalFormOwnerNameInput" density="compact" :error-messages="errors.concat(paxsError)" variant="outlined"
            class="required">
          </v-text-field>
        </Field>
      </v-col>
      <v-col cols="12" sm="4">
        <Field #default="{ errors, field, value }" :immediate="!!animal.id" name="OwnerUnit" rules="required|max:50"
          v-model="animal.ownerUnit">
          <v-text-field @update:model-value="field.onChange" :model-value="value" label="Unité"
            data-cy="AnimalFormOwnerUnitInput" density="compact" :error-messages="errors.concat(paxsError)" class="required"
            variant="outlined">
          </v-text-field>
        </Field>
      </v-col>
      <v-col cols="12" sm="4">
        <Field #default="{ errors, field, value }" :immediate="!!animal.id" name="OwnerRank" rules="required"
          v-model="animal.ownerRank">
          <v-autocomplete @update:model-value="field.onChange" :model-value="value" label="Grade"
            data-cy="AnimalFormOwnerRankInput" density="compact" :error-messages="errors.concat(paxsError)" class="required"
            :items="ranks" :item-title="(rank: Rank) => rank.name + ' - ' + rank.category" variant="outlined" return-object>
          </v-autocomplete>
        </Field>
      </v-col>

      <v-col cols="12" sm="4">
        <Field #default="{ errors, field, value }" :immediate="!!animal.id" name="OwnerObservations" rules="max:255"
          v-model="animal.ownerObservations">
          <v-text-field @update:model-value="field.onChange" :model-value="value" label="Observations"
            data-cy="AnimalFormOwnerObservationsInput" density="compact" :error-messages="errors" variant="outlined">
          </v-text-field>
        </Field>
      </v-col>

      <v-col v-show="false" cols="12" sm="4">
        <Field #default="{ errors, field, value }" ref="paxInput" :immediate="!!animal.id" name="Pax" rules="required"
          v-model="animal.pax">
          <v-text-field @update:model-value="field.onChange" :model-value="value" label="Pax" density="compact"
            :error-messages="errors" class="required" variant="outlined">
          </v-text-field>
        </Field>
      </v-col>
    </v-row>
  </Field>
</template>

<script setup lang="ts">
import { debounce, removeDiacritics } from "../../../mixins/utilsMixin";
import { Animal } from "~/dto/animal.dto";
import { Pax } from "~/dto/pax.dto";
import { Rank } from "~/dto/rank.dto";

const props = defineProps<{
  animal: Animal,
  paxs: Pax[]
}>();

const { ranksLight: ranks } = storeToRefs(useStore());

const paxsError: Ref<string[]> = ref([]);
const formBis: Ref<any> = ref(null);
const paxInput: Ref<any> = ref(null);

const affectPax = () => {
  const pax = props.paxs.find((p: Pax) => {
    const ownerName = removeDiacritics(props.animal.ownerName)?.trim().toLowerCase();
    const paxLastName = removeDiacritics(p.lastName)?.trim().toLowerCase();
    const ownerUnit = removeDiacritics(props.animal.ownerUnit)?.trim().toLowerCase();
    const paxUnit = removeDiacritics(p.unit)?.trim().toLowerCase();
    return ownerName?.includes(paxLastName)
      && ownerUnit === paxUnit
      && props.animal.ownerRank?.id === p.rank?.id
  });
  // @ts-ignore
  props.animal.pax = pax ? { id: pax.id } : null;
  affectPaxError();
}

const affectPaxError = async () => {
  // On attend d'avoir les 3 champs pour afficher les erreurs
  if (!props.animal.ownerName || !props.animal.ownerUnit || !props.animal.ownerRank?.id) {
    return;
  }
  await paxInput.value.validate();
  await formBis.value.validate();
  if (formBis.value?.errors?.Pax && formBis.value?.errors.Pax.length > 0) {
    paxsError.value = ['Aucun PAX ne correspond aux données rentrées'];
  } else {
    paxsError.value = [];
  }
}

onMounted(() => {
  if (props.animal.id) {
    affectPaxError();
  }
})

watch(() => props.animal.ownerName, debounce(function () {
  affectPax();
}, 200));

watch(() => props.animal.ownerUnit, debounce(function () {
  affectPax();
}, 200));

watch(() => props.animal.ownerRank, debounce(function () {
  affectPax();
}, 200));
</script>
